#!/bin/bash

set -e

cargo build --release

trap 'if [ "$?" != "0" ]; then echo "test failed!"; fi' EXIT

examples=(
  donate empty float mutex notify once queue rwlock sem simple sleep water-sem
)

for e in "${examples[@]}"; do
  cargo run --release --example "$e" &
done

wait
