# rt

`rt` is a real-time operating system capable of full preemption.

`rt` provides many familiar synchronization interfaces and implements them with
atomics for high performance and preemptibility. `rt`'s non-blocking interfaces
can be used safely in both tasks and interrupts, and it does not rely on
disabling interrupts to implement synchronization. On architectures without
hardware support for atomics, interrupt masking is used to provide an interface
for atomics with very short gaps in interrupt availability.
