#pragma once

#define RT_ARM_PROFILE_A (__ARM_ARCH_PROFILE == 'A')
#define RT_ARM_PROFILE_R (__ARM_ARCH_PROFILE == 'R')
#define RT_ARM_PROFILE_M (__ARM_ARCH_PROFILE == 'M')

#define RT_ARM_PROFILE_AR (RT_ARM_PROFILE_A || RT_ARM_PROFILE_R)

#define RT_ARM_V6M ((__ARM_ARCH == 6) && RT_ARM_PROFILE_M)
#define RT_ARM_V8M ((__ARM_ARCH == 8) && RT_ARM_PROFILE_M)

#if !RT_ARM_PROFILE_A && !RT_ARM_PROFILE_R && !RT_ARM_PROFILE_M
#error "unknown __ARM_ARCH_PROFILE"
#endif
