@ vim:ft=arm

#include <rt/arch/profile.h>

#if RT_ARM_PROFILE_M

#if __ARM_ARCH == 6 || defined(__ARM_ARCH_8M_BASE__)
#include "m/syscall-v6-v8base.S"
#else
#include "m/syscall-v7-v8.S"
#endif

#include "m/tp.S"

#else // RT_ARM_PROFILE_AR

#include "ar/syscall.S"

#endif // RT_ARM_PROFILE
