# pthread

This code allows `rt` to run on Linux and other POSIX systems for simulation
and testing. Each task is given a pthread, and syscalls and ticks are
implemented as signals that are handled by the active task (thread).

Unfortunately, this code compiles but does not work reliably on macOS, due to a
bug in how `pthread_kill` works on that operating system: sometimes a different
thread will receive a signal than the one passed to `pthread_kill`. This bug is
tracked as [FB11025104](https://feedbackassistant.apple.com/feedback/11025104)
in Apple's Feedback system.
